//
//  Firework.cpp
//  PotVisualizer
//
//  Created by jay on 2014/10/11.
//  Copyright (c) 2014年 jay. All rights reserved.
//

#include "Firework.h"
#include "cstdlib"
#include <math.h>
#include <GLUT/glut.h>
#include <OpenGL/gl.h>
#include <OpenGL/glu.h>

#define GRAVITY 0.012;


Firework::Firework()
{
    numberOfFireParticles = 30;
    float x_start_Location = -4 + (rand()/(float)RAND_MAX)*8;
    float x_start_Velocity = -0.1 + (rand()/(float)RAND_MAX)*0.2;
    float y_start_Velocity =  0.2 + (rand()/(float)RAND_MAX)*0.3;
    red   = 0.5+(rand()/(float)RAND_MAX)*0.5;
    green = 0.5+(rand()/(float)RAND_MAX)*0.5;
    blue  = 0.5+(rand()/(float)RAND_MAX)*0.5;
    Alpha = 0;
    particleSize = 3 + (rand()/(float)RAND_MAX)*3;
    FIREWORK_STATE = HAS_NOT_EXPLODED;

    x = new GLfloat[numberOfFireParticles];
    y = new GLfloat[numberOfFireParticles];
    
    x_speed = new GLfloat[numberOfFireParticles];
    y_speed = new GLfloat[numberOfFireParticles];
    
    for (int i=0; i<numberOfFireParticles; i++)
    {
        x[i] = x_start_Location;
        y[i] = -4;
        x_speed[i] = x_start_Velocity;
        y_speed[i] = y_start_Velocity;
    }


}

Firework::Firework(int Particles)
{
    //numberOfFireworks = Fireworks;
    numberOfFireParticles = Particles;
    
    float x_start_Location = -4 + (rand()/(float)RAND_MAX)*8;
    float x_start_Velocity = -0.1 + (rand()/(float)RAND_MAX)*0.2;
    float y_start_Velocity =  0.2 + (rand()/(float)RAND_MAX)*0.3;
    red   = 0.5+(rand()/(float)RAND_MAX)*0.5;
    green = 0.5+(rand()/(float)RAND_MAX)*0.5;
    blue  = 0.5+(rand()/(float)RAND_MAX)*0.5;
    Alpha = 1;
    particleSize = 3 + (rand()/(float)RAND_MAX)*3;
    FIREWORK_STATE = HAS_NOT_EXPLODED;
    
    x = new GLfloat[numberOfFireParticles];
    y = new GLfloat[numberOfFireParticles];
    
    x_speed = new GLfloat[numberOfFireParticles];
    y_speed = new GLfloat[numberOfFireParticles];
    
    for (int i=0; i<numberOfFireParticles; i++)
    {
        x[i] = x_start_Location;
        y[i] = -4;
        x_speed[i] = x_start_Velocity;
        y_speed[i] = y_start_Velocity;
    }
    
}

void Firework::newFirework()
{
    
    float x_start_Location = -4 + (rand()/(float)RAND_MAX)*8;
    float x_start_Velocity = -0.1 + (rand()/(float)RAND_MAX)*0.2;
    float y_start_Velocity =  0.2 + (rand()/(float)RAND_MAX)*0.3;
    red   = 0.5+(rand()/(float)RAND_MAX)*0.5;
    green = 0.5+(rand()/(float)RAND_MAX)*0.5;
    blue  = 0.5+(rand()/(float)RAND_MAX)*0.5;
    Alpha = 1;
    particleSize = 3 + (rand()/(float)RAND_MAX)*3;
    FIREWORK_STATE = HAS_NOT_EXPLODED;
    
    for (int i=0; i<numberOfFireParticles; i++)
    {
        x[i] = x_start_Location;
        y[i] = -4;
        x_speed[i] = x_start_Velocity;
        y_speed[i] = y_start_Velocity;

    }

}

bool Firework::fireworkState()
{
    return FIREWORK_STATE;
}

void Firework::Move()
{

    glPointSize(particleSize);
    
    if (FIREWORK_STATE == HAS_NOT_EXPLODED)
    {
        glColor4f(1,1,0,Alpha);
        
        for (int i=0; i<numberOfFireParticles; i++)
        {
            x[i] += x_speed[i];
            y[i] += y_speed[i];
            //Draw fireworks
            glBegin(GL_POINTS);
                glVertex2f(x[i],y[i]);
            glEnd();
            
            y_speed[i] -= GRAVITY;
            
            if (y_speed[i]<=0)
            {
                x_speed[i] = -0.2 + (rand()/(float)RAND_MAX)*0.4;
                y_speed[i] = -0.1 + (rand()/(float)RAND_MAX)*0.4;
                FIREWORK_STATE = HAS_EXPLODED;
            }
        }
    }
    else if (FIREWORK_STATE == HAS_EXPLODED)
    {
        glColor4f(red,green,blue,Alpha);
        
        for (int i=0; i<numberOfFireParticles; i++)
        {
            x_speed[i] *= 0.99;
            
            x[i] += x_speed[i];
            y[i] += y_speed[i];
            
            //Draw fireworks
            glBegin(GL_POINTS);
                glVertex2f(x[i],y[i]);
            glEnd();
            
            y_speed[i] -= GRAVITY;
        }
        if (Alpha>0)
            Alpha -= 0.032;
        //else
            //newFirework();
    }
    
}